/********************************************/
/* Modulo stack.h        Fecha: 9/5/2002    */
/* Autores: Carlos del Cacho Vicente y      */
/*          Jose David Alvarez Valentin     */
/* Grupo J9                                 */
/*                                          */
/* Este modulo contiene las estructuras     */
/* que implementan la pila                  */
/********************************************/

#ifndef STACK_H
#define STACK_H
typedef struct pentry_t
{

  void *data;             //Identificador de la entrada
  struct pentry_t *next;    //Siguiente identificador de la entrada
  struct pentry_t *last;    //Siguiente identificador de la entrada

} stack_entry_t;

//--------------------------------------------
/*Estructura con la que se implementa la tabla hash*/
typedef struct 
{
    stack_entry_t *entries;   //Puntero a una lista de entradas
    stack_entry_t *top;
    int data_size;

} stack_t;


void InitStack(stack_t *pila, int entry_size);
stack_entry_t *InsertStack(stack_t *ppila, const void *data);
void *ExtractStack(stack_t *ppila, void *data);
int IsEmpty(stack_t *pila);
void ClearStack(stack_t *pstack);
void *PeekStack(stack_t *pstack, int i);
#endif



